#include "../dnsrh/dnsrh.h"

/* #define LOCAL_V6 "fec0:0001:0002:0003:2300:84ff:fe28:3a25" */
#define LOCAL_V6 "fec0000100020003230084fffe283a25"

int hti(char in) { 
  switch (in) { 
    case '0':
      return 0;
    case '1':
      return 1;
    case '2':
      return 2;
    case '3':
      return 3;
    case '4':
      return 4;
    case '5':
      return 5;
    case '6':
      return 6;
    case '7':
      return 7;
    case '8':
      return 8;
    case '9':
      return 9;
    case 'a':
    case 'A':
      return 10;
    case 'b':
    case 'B':
      return 11;
    case 'c':
    case 'C':
      return 12;
    case 'd':
    case 'D':
      return 13;
    case 'e':
    case 'E':
      return 14;
    case 'f':
    case 'F':
      return 15;
    default:
      return -1;
  }

  return -1;
}

int main() { 
  char * local = { LOCAL_V6 };
  int i = 0;
  int j = 0;
  ip_pair testing;

  printf("string: %s\n", local);

  printf("decimal: ");
  for (i = 0; i < 32; i++) { 
    printf("%d", (hti(local[i]) + hti(local[i + 1])));
    i++;
  }
  printf("\n");

  printf("hex check: ");
  for (i = 0; i < 32; i++) { 
    printf("%x", hti(local[i]));
  }
  printf("\n");


  /* TESTING */
  for (i = 0; i < 16; i++) 
    testing.v6[i] = 0;

  j = 0;
  printf("testing assign: ");
  for (i = 0; i < 16; i++) {
    testing.v6[i] = (unsigned char) ((testing.v6[i] | hti(local[j])) << 4) & 0xF0;
    printf("%x", testing.v6[i]);

    testing.v6[i] += (unsigned char) (testing.v6[i] | hti(local[j + 1])) & 0x0F;
    printf("%x", testing.v6[i]); 

    j += 2;
  }
  printf("\n");

  printf("back to hex: %x%x%x%x%x%x%x%x%x%x%x%x%x%x%x%x\n", testing.v6[0], testing.v6[1], testing.v6[2], testing.v6[3], testing.v6[4], testing.v6[5], testing.v6[6], testing.v6[7], testing.v6[8], testing.v6[9], testing.v6[10], testing.v6[11], testing.v6[12], testing.v6[13], testing.v6[14], testing.v6[15]);


  return 0;
}
